import tkinter as tk
import subprocess as sub
import tkinter.messagebox as msg
import time

from sqlalchemy import false

root = tk.Tk()
root.geometry("400x200")
root.title("Theme Changer")


def dark_click():
    command = ['reg.exe', 'add', 'HKCU\SOFTWARE\Microsoft\Windows\CurrentVersion\Themes\Personalize',
               '/v', 'AppsUseLightTheme', '/t', 'REG_DWORD', '/d', '0', '/f']
    sub. run(command)


def light_click():
    command = ["reg.exe", "add", "HKCU\SOFTWARE\Microsoft\Windows\CurrentVersion\Themes\Personalize",
               "/v", "AppsUseLightTheme", "/t", "REG_DWORD", "/d", "1", "/f"]
    sub. run(command)

#引用元
#https://stackoverflow.com/questions/63816241/set-the-color-settings-of-windows-10-in-python


def auto_click():
    darkTime = darkText.get()
    lightTime = lightText.get()

    if (lightTime<"0") or (lightTime>"23") or (darkTime<"0") or(darkTime>"23"):
        msg.showerror(title="Error", message="This is invaild input.")
        return
    
    isDarkVaild = int(darkTime) in range(0, 24)
    isLightVaild = int(lightTime) in range(0, 24)
    
    if lightTime == "" or darkTime == "" or isDarkVaild == False or isLightVaild == False:
        msg.showerror(title="Error", message="This is invaild input.")
        return

    while True:
        currentHour = time.strftime("%H")  # get current hour

        if currentHour == darkTime:
            dark_click()
        elif currentHour == lightTime:
            light_click()

        time.sleep(3600)  # wait for 1 hour


darkButton = tk.Button(root, text="Dark  Mode On", command=dark_click)
lightButton = tk.Button(root, text="Light Mode On", command=light_click)
autoButton = tk.Button(root, text="Auto Change", command=auto_click)

lightLabel = tk.Label(text="Time to change to Light Mode(24h)")
lightLabel.place(x=40, y=140)

lightText = tk.Entry(width=20)
lightText.place(x=250, y=140)

darkLabel = tk.Label(text="Time to change to Dark Mode(24h)")
darkLabel.place(x=40, y=170)

darkText = tk.Entry(width=20)
darkText.place(x=250, y=170)

darkButton.place(x=50, y=60)
lightButton.place(x=270, y=60)
autoButton.place(x=160, y=110)


root.mainloop()
